
mod imp;

use glib::Object;
use gtk::{gio, glib::{self, subclass::types::ObjectSubclassIsExt}, Application};

glib::wrapper! {
    pub struct MemoryCardsGameScene(ObjectSubclass<imp::MemoryCardsGameScene>)
        @extends gtk::ApplicationWindow, gtk::Window, gtk::Widget,
        @implements gio::ActionGroup, gio::ActionMap, gtk::Accessible, gtk::Buildable,
                    gtk::ConstraintTarget, gtk::Native, gtk::Root, gtk::ShortcutManager;
}

impl MemoryCardsGameScene {
    pub fn new(app: &Application) -> Self {
        Object::builder().property("application", app).build()
    }

    // pub fn set_stats(&self, correct: usize, incorrect: usize) {
    //     self.imp().stats_label.set_text(&format!("Correct|Incorrect: {correct}|{incorrect}"));
    // }

    pub fn update_stats(&self) {
        self.imp().stats_label.set_text(&format!("Correct|Incorrect: {}|{}", self.imp().correct.borrow(), self.imp().incorrect.borrow()));
    }

    // pub fn get_stats(&self) -> (usize, usize) {
    //     (self.imp().correct, self.imp().incorrect)
    // }

    // pub fn set_stats(&self, correct: usize, incorrect: usize) {
    //     self.imp().correct = correct;
    //     self.imp().incorrect = incorrect;
    // } 
}
